// подключение библиотеки SoftwareSerial
#include <SoftwareSerial.h>
// создание экземпляра SoftwareSerial
// на RX-3, TX-2 
SoftwareSerial mySerial(3, 2); 
// пин Arduino, к которому подключены выводы RE и DE 
// конвертирующего модуля (выбор передача/получение)
const int PIN_TX_RX = 6;  
unsigned long millis1,millis2;
// строка для получаемых данных
String inputString0 = "";     
// признак конца строки
boolean stringComplete0 = false;  

void setup(){
  // устанавливаем режим PIN_TX_RX, как OUTPUT
  pinMode(PIN_TX_RX,OUTPUT);    
  // в режим получения данных
  digitalWrite(PIN_TX_RX, LOW);    
  // Инициализируем последовательный порт
  Serial.begin(9600);
  // устанавливаем скорость передачи данных 
  // для последовательного порта, созданного 
  // библиотекой SoftwareSerial
  mySerial.begin(9600);
}
 
void loop() {
 serialEvent0();  
  if (stringComplete0) {
    Serial.print(inputString0);    
    // control a sign of correct data
    if(inputString0.charAt(0) == '1' ) {
       // в режим передачи данных
       digitalWrite(PIN_TX_RX, HIGH);    
       delay(10);
       mySerial.print("OK");
       delay(10);
       // в режим получения данных
       digitalWrite(PIN_TX_RX, LOW);    
    }
    inputString0 = "";
    stringComplete0 = false;
   }    
}

// получение данных по последовательному порту 
void serialEvent0() {
  if (mySerial.available() > 0) {
    // get byte:
    char inChar = (char)mySerial.read();
    // add to string
    inputString0 += inChar;
    Serial.print(inChar);
    // /n - end of transmission
    if (inChar == '*') {
      stringComplete0 = true;
    }
  }
}

